Index: palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- palm/trunk/SOURCE/data_output_module.f90	(revision 4146)
+++ palm/trunk/SOURCE/data_output_module.f90	(revision 4147)
@@ -1224,56 +1230,56 @@
 !>                   value=1.0_4 )
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_real32( file_name, variable_name, attribute_name, value, append ) &
-            RESULT( return_value )
-
-   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
-   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
-   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
-   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_real32'  !< name of routine
-
-   INTEGER ::  return_value  !< return value
-
-   LOGICAL                       ::  append_internal  !< same as 'append'
-   LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
-
-   REAL(KIND=4), INTENT(IN) ::  value  !< attribute value
-
-   TYPE(attribute_type) ::  attribute  !< new attribute
-
-
-   return_value = 0
-
-   IF ( PRESENT( variable_name ) )  THEN
-      variable_name_internal = TRIM( variable_name )
-   ELSE
-      variable_name_internal = ''
-   ENDIF
-
-   IF ( PRESENT( append ) )  THEN
-      IF ( append )  THEN
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                             &
-                                ': numeric attribute cannot be appended ' //         &
-                                '(attribute "' // TRIM( attribute_name ) //          &
-                                '", variable "' // TRIM( variable_name_internal ) // &
-                                '", file "' // TRIM( file_name ) // '")!' )
-      ENDIF
-   ENDIF
-
-   IF ( return_value == 0 )  THEN
-      append_internal = .FALSE.
-
-      attribute%name         = TRIM( attribute_name )
-      attribute%data_type    = 'real32'
-      attribute%value_real32 = value
-
-      return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
-                        variable_name=TRIM( variable_name_internal ),         &
-                        attribute=attribute, append=append_internal )
-   ENDIF
-
-END FUNCTION dom_def_att_real32
+ FUNCTION dom_def_att_real32( file_name, variable_name, attribute_name, value, append ) &
+             RESULT( return_value )
+
+    CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+    CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+    CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+    CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_real32'  !< name of routine
+
+    INTEGER ::  return_value  !< return value
+
+    LOGICAL                       ::  append_internal  !< same as 'append'
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
+
+    REAL(KIND=4), INTENT(IN) ::  value  !< attribute value
+
+    TYPE(attribute_type) ::  attribute  !< new attribute
+
+
+    return_value = 0
+
+    IF ( PRESENT( variable_name ) )  THEN
+       variable_name_internal = TRIM( variable_name )
+    ELSE
+       variable_name_internal = ''
+    ENDIF
+
+    IF ( PRESENT( append ) )  THEN
+       IF ( append )  THEN
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                             &
+                                 ': numeric attribute cannot be appended ' //         &
+                                 '(attribute "' // TRIM( attribute_name ) //          &
+                                 '", variable "' // TRIM( variable_name_internal ) // &
+                                 '", file "' // TRIM( file_name ) // '")!' )
+       ENDIF
+    ENDIF
+
+    IF ( return_value == 0 )  THEN
+       append_internal = .FALSE.
+
+       attribute%name         = TRIM( attribute_name )
+       attribute%data_type    = 'real32'
+       attribute%value_real32 = value
+
+       return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                         variable_name=TRIM( variable_name_internal ),         &
+                         attribute=attribute, append=append_internal )
+    ENDIF
+
+ END FUNCTION dom_def_att_real32
 
 !--------------------------------------------------------------------------------------------------!
@@ -1296,56 +1302,56 @@
 !>                   value=1.0_8 )
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_real64( file_name, variable_name, attribute_name, value, append ) &
-            RESULT( return_value )
-
-   CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
-   CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
-   CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
-   CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_real64'  !< name of routine
-
-   INTEGER ::  return_value  !< return value
-
-   LOGICAL                       ::  append_internal  !< same as 'append'
-   LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
-
-   REAL(KIND=8), INTENT(IN) ::  value  !< attribute value
-
-   TYPE(attribute_type) ::  attribute  !< new attribute
-
-
-   return_value = 0
-
-   IF ( PRESENT( variable_name ) )  THEN
-      variable_name_internal = TRIM( variable_name )
-   ELSE
-      variable_name_internal = ''
-   ENDIF
-
-   IF ( PRESENT( append ) )  THEN
-      IF ( append )  THEN
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                             &
-                                ': numeric attribute cannot be appended ' //         &
-                                '(attribute "' // TRIM( attribute_name ) //          &
-                                '", variable "' // TRIM( variable_name_internal ) // &
-                                '", file "' // TRIM( file_name ) // '")!' )
-      ENDIF
-   ENDIF
-
-   IF ( return_value == 0 )  THEN
-      append_internal = .FALSE.
-
-      attribute%name         = TRIM( attribute_name )
-      attribute%data_type    = 'real64'
-      attribute%value_real64 = value
-
-      return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
-                        variable_name=TRIM( variable_name_internal ),         &
-                        attribute=attribute, append=append_internal )
-   ENDIF
-
-END FUNCTION dom_def_att_real64
+ FUNCTION dom_def_att_real64( file_name, variable_name, attribute_name, value, append ) &
+             RESULT( return_value )
+
+    CHARACTER(LEN=*),      INTENT(IN)           ::  file_name               !< name of file
+    CHARACTER(LEN=*),      INTENT(IN)           ::  attribute_name          !< name of attribute
+    CHARACTER(LEN=*),      INTENT(IN), OPTIONAL ::  variable_name           !< name of variable
+    CHARACTER(LEN=charlen)                      ::  variable_name_internal  !< internal copy of variable_name
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_real64'  !< name of routine
+
+    INTEGER ::  return_value  !< return value
+
+    LOGICAL                       ::  append_internal  !< same as 'append'
+    LOGICAL, INTENT(IN), OPTIONAL ::  append           !< if true, append value to existing value
+
+    REAL(KIND=8), INTENT(IN) ::  value  !< attribute value
+
+    TYPE(attribute_type) ::  attribute  !< new attribute
+
+
+    return_value = 0
+
+    IF ( PRESENT( variable_name ) )  THEN
+       variable_name_internal = TRIM( variable_name )
+    ELSE
+       variable_name_internal = ''
+    ENDIF
+
+    IF ( PRESENT( append ) )  THEN
+       IF ( append )  THEN
+          return_value = 1
+          CALL internal_message( 'error', routine_name //                             &
+                                 ': numeric attribute cannot be appended ' //         &
+                                 '(attribute "' // TRIM( attribute_name ) //          &
+                                 '", variable "' // TRIM( variable_name_internal ) // &
+                                 '", file "' // TRIM( file_name ) // '")!' )
+       ENDIF
+    ENDIF
+
+    IF ( return_value == 0 )  THEN
+       append_internal = .FALSE.
+
+       attribute%name         = TRIM( attribute_name )
+       attribute%data_type    = 'real64'
+       attribute%value_real64 = value
+
+       return_value = save_attribute_in_database( file_name=TRIM( file_name ), &
+                         variable_name=TRIM( variable_name_internal ),         &
+                         attribute=attribute, append=append_internal )
+    ENDIF
+
+ END FUNCTION dom_def_att_real64
 
 !--------------------------------------------------------------------------------------------------!
@@ -1357,151 +1363,151 @@
 !> to the files.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_end() RESULT( return_value )
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_end'  !< name of routine
-
-   INTEGER ::  d             !< loop index
-   INTEGER ::  f             !< loop index
-   INTEGER ::  return_value  !< return value
-
-   INTEGER(KIND=1), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int8           !< target array for dimension values
-   INTEGER(KIND=2), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int16          !< target array for dimension values
-   INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int32          !< target array for dimension values
-   INTEGER(iwp),    DIMENSION(:), ALLOCATABLE, TARGET ::  values_intwp          !< target array for dimension values
-   
-   INTEGER(KIND=1), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int8_pointer   !< pointer to target array
-   INTEGER(KIND=2), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int16_pointer  !< pointer to target array
-   INTEGER(KIND=4), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int32_pointer  !< pointer to target array
-   INTEGER(iwp),    DIMENSION(:), POINTER, CONTIGUOUS ::  values_intwp_pointer  !< pointer to target array
-
-   REAL(KIND=4), DIMENSION(:), ALLOCATABLE, TARGET ::  values_real32            !< target array for dimension values
-   REAL(KIND=8), DIMENSION(:), ALLOCATABLE, TARGET ::  values_real64            !< target array for dimension values
-   REAL(wp),     DIMENSION(:), ALLOCATABLE, TARGET ::  values_realwp            !< target array for dimension values
-
-   REAL(KIND=4), DIMENSION(:), POINTER, CONTIGUOUS ::  values_real32_pointer    !< pointer to target array
-   REAL(KIND=8), DIMENSION(:), POINTER, CONTIGUOUS ::  values_real64_pointer    !< pointer to target array
-   REAL(wp),     DIMENSION(:), POINTER, CONTIGUOUS ::  values_realwp_pointer    !< pointer to target array
-
-
-   return_value = 0
-   CALL internal_message( 'debug', routine_name // ': start' )
-
-   !-- Clear database from empty files and unused dimensions
-   IF ( nfiles > 0 )  return_value = cleanup_database()
-
-   IF ( return_value == 0 )  THEN
-      DO  f = 1, nfiles
-
-         !-- Skip initialization if file is already initialized
-         IF ( files(f)%is_init )  CYCLE
-
-         CALL internal_message( 'debug', routine_name // ': initialize file "' // &
-                                TRIM( files(f)%name ) // '"' )
-
-         !-- Open file
-         CALL open_output_file( files(f)%format, files(f)%name, files(f)%id, &
-                                return_value=return_value )
-
-         !-- Initialize file header:
-         !-- define dimensions and variables and write attributes
-         IF ( return_value == 0 )  &
-            CALL init_file_header( files(f), return_value=return_value )
-
-         !-- End file definition
-         IF ( return_value == 0 )  &
-            CALL stop_file_header_definition( files(f)%format, files(f)%id, &
-                                              files(f)%name, return_value )
-
-         IF ( return_value == 0 )  THEN
-
-            !-- Flag file as initialized
-            files(f)%is_init = .TRUE.
-
-            !-- Write dimension values into file
-            DO  d = 1, SIZE( files(f)%dimensions )
-               IF ( ALLOCATED( files(f)%dimensions(d)%values_int8 ) )  THEN
-                  ALLOCATE( values_int8(files(f)%dimensions(d)%bounds(1): &
-                                        files(f)%dimensions(d)%bounds(2)) )
-                  values_int8 = files(f)%dimensions(d)%values_int8
-                  values_int8_pointer => values_int8
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    values_int8_1d=values_int8_pointer )
-                  DEALLOCATE( values_int8 )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_int16 ) )  THEN
-                  ALLOCATE( values_int16(files(f)%dimensions(d)%bounds(1): &
+ FUNCTION dom_def_end() RESULT( return_value )
+
+    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_end'  !< name of routine
+
+    INTEGER ::  d             !< loop index
+    INTEGER ::  f             !< loop index
+    INTEGER ::  return_value  !< return value
+
+    INTEGER(KIND=1), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int8           !< target array for dimension values
+    INTEGER(KIND=2), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int16          !< target array for dimension values
+    INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int32          !< target array for dimension values
+    INTEGER(iwp),    DIMENSION(:), ALLOCATABLE, TARGET ::  values_intwp          !< target array for dimension values
+
+    INTEGER(KIND=1), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int8_pointer   !< pointer to target array
+    INTEGER(KIND=2), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int16_pointer  !< pointer to target array
+    INTEGER(KIND=4), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int32_pointer  !< pointer to target array
+    INTEGER(iwp),    DIMENSION(:), POINTER, CONTIGUOUS ::  values_intwp_pointer  !< pointer to target array
+
+    REAL(KIND=4), DIMENSION(:), ALLOCATABLE, TARGET ::  values_real32            !< target array for dimension values
+    REAL(KIND=8), DIMENSION(:), ALLOCATABLE, TARGET ::  values_real64            !< target array for dimension values
+    REAL(wp),     DIMENSION(:), ALLOCATABLE, TARGET ::  values_realwp            !< target array for dimension values
+
+    REAL(KIND=4), DIMENSION(:), POINTER, CONTIGUOUS ::  values_real32_pointer    !< pointer to target array
+    REAL(KIND=8), DIMENSION(:), POINTER, CONTIGUOUS ::  values_real64_pointer    !< pointer to target array
+    REAL(wp),     DIMENSION(:), POINTER, CONTIGUOUS ::  values_realwp_pointer    !< pointer to target array
+
+
+    return_value = 0
+    CALL internal_message( 'debug', routine_name // ': start' )
+!
+!-- Clear database from empty files and unused dimensions
+    IF ( nfiles > 0 )  return_value = cleanup_database()
+
+    IF ( return_value == 0 )  THEN
+       DO  f = 1, nfiles
+!
+!--       Skip initialization if file is already initialized
+          IF ( files(f)%is_init )  CYCLE
+
+          CALL internal_message( 'debug', routine_name // ': initialize file "' // &
+                                 TRIM( files(f)%name ) // '"' )
+!
+!--       Open file
+          CALL open_output_file( files(f)%format, files(f)%name, files(f)%id, &
+                                 return_value=return_value )
+!
+!--       Initialize file header:
+!--       define dimensions and variables and write attributes
+          IF ( return_value == 0 )  &
+             CALL init_file_header( files(f), return_value=return_value )
+!
+!--       End file definition
+          IF ( return_value == 0 )  &
+             CALL stop_file_header_definition( files(f)%format, files(f)%id, &
+                                               files(f)%name, return_value )
+
+          IF ( return_value == 0 )  THEN
+!
+!--          Flag file as initialized
+             files(f)%is_init = .TRUE.
+!
+!--          Write dimension values into file
+             DO  d = 1, SIZE( files(f)%dimensions )
+                IF ( ALLOCATED( files(f)%dimensions(d)%values_int8 ) )  THEN
+                   ALLOCATE( values_int8(files(f)%dimensions(d)%bounds(1): &
                                          files(f)%dimensions(d)%bounds(2)) )
-                  values_int16 = files(f)%dimensions(d)%values_int16
-                  values_int16_pointer => values_int16
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    values_int16_1d=values_int16_pointer )
-                  DEALLOCATE( values_int16 )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_int32 ) )  THEN
-                  ALLOCATE( values_int32(files(f)%dimensions(d)%bounds(1): &
-                                         files(f)%dimensions(d)%bounds(2)) )
-                  values_int32 = files(f)%dimensions(d)%values_int32
-                  values_int32_pointer => values_int32
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    values_int32_1d=values_int32_pointer )
-                  DEALLOCATE( values_int32 )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_intwp ) )  THEN
-                  ALLOCATE( values_intwp(files(f)%dimensions(d)%bounds(1): &
-                                         files(f)%dimensions(d)%bounds(2)) )
-                  values_intwp = files(f)%dimensions(d)%values_intwp
-                  values_intwp_pointer => values_intwp
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    values_intwp_1d=values_intwp_pointer )
-                  DEALLOCATE( values_intwp )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_real32 ) )  THEN
-                  ALLOCATE( values_real32(files(f)%dimensions(d)%bounds(1): &
+                   values_int8 = files(f)%dimensions(d)%values_int8
+                   values_int8_pointer => values_int8
+                   return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                     bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                     bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                     values_int8_1d=values_int8_pointer )
+                   DEALLOCATE( values_int8 )
+                ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_int16 ) )  THEN
+                   ALLOCATE( values_int16(files(f)%dimensions(d)%bounds(1): &
                                           files(f)%dimensions(d)%bounds(2)) )
-                  values_real32 = files(f)%dimensions(d)%values_real32
-                  values_real32_pointer => values_real32
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    values_real32_1d=values_real32_pointer )
-                  DEALLOCATE( values_real32 )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_real64 ) )  THEN
-                  ALLOCATE( values_real64(files(f)%dimensions(d)%bounds(1): &
+                   values_int16 = files(f)%dimensions(d)%values_int16
+                   values_int16_pointer => values_int16
+                   return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                     bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                     bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                     values_int16_1d=values_int16_pointer )
+                   DEALLOCATE( values_int16 )
+                ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_int32 ) )  THEN
+                   ALLOCATE( values_int32(files(f)%dimensions(d)%bounds(1): &
                                           files(f)%dimensions(d)%bounds(2)) )
-                  values_real64 = files(f)%dimensions(d)%values_real64
-                  values_real64_pointer => values_real64
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    values_real64_1d=values_real64_pointer )
-                  DEALLOCATE( values_real64 )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_realwp ) )  THEN
-                  ALLOCATE( values_realwp(files(f)%dimensions(d)%bounds(1): &
+                   values_int32 = files(f)%dimensions(d)%values_int32
+                   values_int32_pointer => values_int32
+                   return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                     bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                     bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                     values_int32_1d=values_int32_pointer )
+                   DEALLOCATE( values_int32 )
+                ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_intwp ) )  THEN
+                   ALLOCATE( values_intwp(files(f)%dimensions(d)%bounds(1): &
                                           files(f)%dimensions(d)%bounds(2)) )
-                  values_realwp = files(f)%dimensions(d)%values_realwp
-                  values_realwp_pointer => values_realwp
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    values_realwp_1d=values_realwp_pointer )
-                  DEALLOCATE( values_realwp )
-               ENDIF
-               IF ( return_value /= 0 )  EXIT
-            ENDDO
-
-         ENDIF
-
-         IF ( return_value /= 0 )  EXIT
-
-      ENDDO
-   ENDIF
-
-   CALL internal_message( 'debug', routine_name // ': finished' )
-
-END FUNCTION dom_def_end
+                   values_intwp = files(f)%dimensions(d)%values_intwp
+                   values_intwp_pointer => values_intwp
+                   return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                     bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                     bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                     values_intwp_1d=values_intwp_pointer )
+                   DEALLOCATE( values_intwp )
+                ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_real32 ) )  THEN
+                   ALLOCATE( values_real32(files(f)%dimensions(d)%bounds(1): &
+                                           files(f)%dimensions(d)%bounds(2)) )
+                   values_real32 = files(f)%dimensions(d)%values_real32
+                   values_real32_pointer => values_real32
+                   return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                     bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                     bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                     values_real32_1d=values_real32_pointer )
+                   DEALLOCATE( values_real32 )
+                ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_real64 ) )  THEN
+                   ALLOCATE( values_real64(files(f)%dimensions(d)%bounds(1): &
+                                           files(f)%dimensions(d)%bounds(2)) )
+                   values_real64 = files(f)%dimensions(d)%values_real64
+                   values_real64_pointer => values_real64
+                   return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                     bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                     bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                     values_real64_1d=values_real64_pointer )
+                   DEALLOCATE( values_real64 )
+                ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_realwp ) )  THEN
+                   ALLOCATE( values_realwp(files(f)%dimensions(d)%bounds(1): &
+                                           files(f)%dimensions(d)%bounds(2)) )
+                   values_realwp = files(f)%dimensions(d)%values_realwp
+                   values_realwp_pointer => values_realwp
+                   return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
+                                     bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
+                                     bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
+                                     values_realwp_1d=values_realwp_pointer )
+                   DEALLOCATE( values_realwp )
+                ENDIF
+                IF ( return_value /= 0 )  EXIT
+             ENDDO
+
+          ENDIF
+
+          IF ( return_value /= 0 )  EXIT
+
+       ENDDO
+    ENDIF
+
+    CALL internal_message( 'debug', routine_name // ': finished' )
+
+ END FUNCTION dom_def_end
 
 !--------------------------------------------------------------------------------------------------!
